- [HTTP request](https://docs.cloud.google.com/security-command-center/docs/reference/rest/v1/projects.sources.findings/group#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/security-command-center/docs/reference/rest/v1/projects.sources.findings/group#body.PATH_PARAMETERS)
- [Request body](https://docs.cloud.google.com/security-command-center/docs/reference/rest/v1/projects.sources.findings/group#body.request_body)
  - [JSON representation](https://docs.cloud.google.com/security-command-center/docs/reference/rest/v1/projects.sources.findings/group#body.request_body.SCHEMA_REPRESENTATION)
- [Response body](https://docs.cloud.google.com/security-command-center/docs/reference/rest/v1/projects.sources.findings/group#body.response_body)
- [Authorization scopes](https://docs.cloud.google.com/security-command-center/docs/reference/rest/v1/projects.sources.findings/group#body.aspect)
- [Try it!](https://docs.cloud.google.com/security-command-center/docs/reference/rest/v1/projects.sources.findings/group#try-it)

Filters an organization or source's findings and groups them by their specified properties.

To group across all sources provide a `-` as the source id. Example: /v1/organizations/{organizationId}/sources/-/findings, /v1/folders/{folder_id}/sources/-/findings, /v1/projects/{projectId}/sources/-/findings

### IAM Permissions

Requires the following IAM permission on the resource specified in the `parent` field:

- `securitycenter.findings.group`

### HTTP request

Choose an endpoint:
global me-central2 us eu   
`POST https://securitycenter.googleapis.com/v1/{parent=projects/*/sources/*}/findings:group`

<br />

The URLs use [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `parent` | `string` Required. Name of the source to groupBy. Its format is `organizations/[organizationId]/sources/[source_id]`, `folders/[folder_id]/sources/[source_id]`, or `projects/[projectId]/sources/[source_id]`. To groupBy across all sources provide a source_id of `-`. For example: `organizations/{organizationId}/sources/-, folders/{folder_id}/sources/-`, or `projects/{projectId}/sources/-` |

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "filter": string, "groupBy": string, "readTime": string, "compareDuration": string, "pageToken": string, "pageSize": integer } ``` |

| Fields ||
|---|---|
| `filter` | `string` Expression that defines the filter to apply across findings. The expression is a list of one or more restrictions combined via logical operators `AND` and `OR`. Parentheses are supported, and `OR` has higher precedence than `AND`. Restrictions have the form `<field> <operator> <value>` and may have a `-` character in front of them to indicate negation. Examples include: - name - sourceProperties.a_property - securityMarks.marks.marka The supported operators are: - `=` for all value types. - `>`, `<`, `>=`, `<=` for integer values. - `:`, meaning substring matching, for strings. The supported value types are: - string literals in quotes. - integer literals without quotes. - boolean literals `true` and `false` without quotes. The following field and operator combinations are supported: - name: `=` - parent: `=`, `:` - resourceName: `=`, `:` - state: `=`, `:` - category: `=`, `:` - externalUri: `=`, `:` - eventTime: `=`, `>`, `<`, `>=`, `<=` Usage: This should be milliseconds since epoch or an RFC3339 string. Examples: `eventTime = "2019-06-10T16:07:18-07:00"` `eventTime = 1560208038000` - severity: `=`, `:` - workflowState: `=`, `:` - securityMarks.marks: `=`, `:` - sourceProperties: `=`, `:`, `>`, `<`, `>=`, `<=` For example, `sourceProperties.size = 100` is a valid filter string. Use a partial match on the empty string to filter based on a property existing: `sourceProperties.my_property : ""` Use a negated partial match on the empty string to filter based on a property not existing: `-sourceProperties.my_property : ""` - resource: - resource.name: `=`, `:` - resource.parent_name: `=`, `:` - resource.parent_display_name: `=`, `:` - resource.project_name: `=`, `:` - resource.project_display_name: `=`, `:` - resource.type: `=`, `:` |
| `groupBy` | `string` Required. Expression that defines what assets fields to use for grouping (including `stateChange`). The string value should follow SQL syntax: comma separated list of fields. For example: "parent,resourceName". The following fields are supported when compareDuration is set: - stateChange |
| `readTime (deprecated)` | ``string (`https://protobuf.dev/reference/protobuf/google.protobuf#timestamp` format)`` Time used as a reference point when filtering findings. The filter is limited to findings existing at the supplied time and their values are those at that specific time. Absence of this field will default to the API's version of NOW. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: `"2014-10-02T15:01:23Z"`, `"2014-10-02T15:01:23.045123456Z"` or `"2014-10-02T15:01:23+05:30"`. |
| `compareDuration (deprecated)` | ``string (`https://protobuf.dev/reference/protobuf/google.protobuf#duration` format)`` When compareDuration is set, the GroupResult's "stateChange" attribute is updated to indicate whether the finding had its state changed, the finding's state remained unchanged, or if the finding was added during the compareDuration period of time that precedes the readTime. This is the time between (readTime - compareDuration) and readTime. The stateChange value is derived based on the presence and state of the finding at the two points in time. Intermediate state changes between the two times don't affect the result. For example, the results aren't affected if the finding is made inactive and then active again. Possible "stateChange" values when compareDuration is specified: - "CHANGED": indicates that the finding was present and matched the given filter at the start of compareDuration, but changed its state at readTime. - "UNCHANGED": indicates that the finding was present and matched the given filter at the start of compareDuration and did not change state at readTime. - "ADDED": indicates that the finding did not match the given filter or was not present at the start of compareDuration, but was present at readTime. - "REMOVED": indicates that the finding was present and matched the filter at the start of compareDuration, but did not match the filter at readTime. If compareDuration is not specified, then the only possible stateChange is "UNUSED", which will be the stateChange set for all findings present at readTime. If this field is set then `stateChange` must be a specified field in `groupBy`. A duration in seconds with up to nine fractional digits, ending with '`s`'. Example: `"3.5s"`. |
| `pageToken` | `string` The value returned by the last `GroupFindingsResponse`; indicates that this is a continuation of a prior `findings.group` call, and that the system should return the next page of data. |
| `pageSize` | `integer` The maximum number of results to return in a single response. Default is 10, minimum is 1, maximum is 1000. |

### Response body

If successful, the response body contains an instance of `https://docs.cloud.google.com/security-command-center/docs/reference/rest/v1/GroupFindingsResponse`.

### Authorization scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/cloud-platform`
- `https://www.googleapis.com/auth/securitycenter`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).